stages:
  - verify
  - build

verify:
  stage: verify
  image: docker:20.10-dind
  services:
    - docker:dind
  script:
    - docker info

.build-docker-image:
  stage: build
  image: docker:20.10-dind
  services:
    - docker:dind
  before_script:
    - echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY
    - cd docker
  script:
    - docker pull $REGISTRY:latest || true
    - docker build --cache-from $REGISTRY:latest -t $REGISTRY:$CI_COMMIT_SHA -t $REGISTRY:latest -f ./$IMAGE/Dockerfile ./$IMAGE
    - docker push $REGISTRY:$CI_COMMIT_SHA
    - docker push $REGISTRY:latest

build-image-echo-request:
  extends: .build-docker-image
  variables:
    REGISTRY: $CI_REGISTRY_IMAGE/echo-request
    IMAGE: golang


build-image-nginx-proxy:
  extends: .build-docker-image
  variables:
    REGISTRY:  $CI_REGISTRY_IMAGE/nginx-proxy
    IMAGE: nginx


